/* (1)  Print P# of all red parts. */

Select distinct P# FROM  P  WHERE COLOR='Red' ;

/* (2)    Print S#s of suppliers who supply a part in common 
          with a supplier who supplies a red part. */

Select distinct SPJX.S#  from SPJ SPJX,SPJ SPJY,SPJ SPJZ,P WHERE P.COLOR='Red'
AND SPJX.P#=SPJY.P# AND SPJY.S#=SPJZ.S# AND SPJZ.P#=P.P# ;

/* (3)    Print J#s of projects that do not get a red part from 
          a London supplier. */

Select distinct J# FROM J EXCEPT Select distinct SPJ.J#  from SPJ,P,S WHERE
P.COLOR='Red' AND S.CITY='London' AND SPJ.P#=P.P# AND SPJ.S#=S.S# ;

/* (4)    Print J#s of projects supplied entirely by S1. */

Select distinct J# FROM SPJ EXCEPT Select distinct J# FROM  SPJ  WHERE S#<>'S1'
;

/* (5)    Print the cities that appear either in the S, P, or J 
          table: */

Select distinct CITY FROM S UNION Select distinct CITY FROM P UNION Select
distinct CITY FROM J;

/* (6)  Print S#s of suppliers who supply all parts. */

Select distinct S# from SPJ R1x where (select count (*) from (Select distinct
S#,P# from SPJ a11) R1y, (Select distinct P# from P a22) R2x where
R1y.S#=R1x.S# AND R1y.P#=R2x.P#) = (select count (*) from (Select distinct P#
from P a33 ) a44);

/* (7)   Print P#s of parts supplied to all London projects. */

Select distinct P# from SPJ R1x where (select count (*) from (Select distinct
P#,J# from SPJ a11) R1y, (Select distinct J# from (Select distinct J# FROM  J
 WHERE CITY='London' ) a22) R2x where R1y.P#=R1x.P# AND R1y.J#=R2x.J#) =
(select count (*) from (Select distinct J# from (Select distinct J# FROM  J
 WHERE CITY='London' ) a33 ) a44);

/* (8)   Print S#s for suppliers who ship the same part to all
         projects. */

Select distinct S# FROM ( Select distinct S#,P# from SPJ R1x where (select
count (*) from (Select distinct S#,P#,J# from SPJ a11) R1y, (Select distinct J#
from J a22) R2x where R1y.S#=R1x.S# AND R1y.P#=R1x.P# AND R1y.J#=R2x.J#) =
(select count (*) from (Select distinct J# from J a33 ) a44) ) jm;

/* (9)    Print J#s of projects supplied with all parts 
          available from S1. */

Select distinct J# from SPJ R1x where (select count (*) from (Select distinct
J#,P# from SPJ a11) R1y, (Select distinct P# from (Select distinct P# FROM  SPJ
 WHERE S#='S1' ) a22) R2x where R1y.J#=R1x.J# AND R1y.P#=R2x.P#) = (select
count (*) from (Select distinct P# from (Select distinct P# FROM  SPJ  WHERE
S#='S1' ) a33 ) a44);

/* (10) Print S#s of suppliers who supply all parts to all projects. */

Select distinct S# from SPJ R1x where (select count (*) from (Select distinct
S#,P#,J# from SPJ a11) R1y, (Select distinct P#,J# from ( Select distinct P#,J#
from P cross join J ) a22) R2x where R1y.S#=R1x.S# AND R1y.P#=R2x.P# AND
R1y.J#=R2x.J#) = (select count (*) from (Select distinct P#,J# from ( Select
distinct P#,J# from P cross join J ) a33 ) a44);

/* (11) Print S#s of suppliers who supply all parts that are 
     supplied to all projects. */

Select distinct S# from SPJ R1x where (select count (*) from (Select distinct
S#,P# from SPJ a11) R1y, (Select distinct P# from ( Select distinct P# from SPJ
R1x where (select count (*) from (Select distinct P#,J# from SPJ a11) R1y,
(Select distinct J# from J a22) R2x where R1y.P#=R1x.P# AND R1y.J#=R2x.J#) =
(select count (*) from (Select distinct J# from J a33 ) a44) ) a22) R2x where
R1y.S#=R1x.S# AND R1y.P#=R2x.P#) = (select count (*) from (Select distinct P#
from ( Select distinct P# from SPJ R1x where (select count (*) from (Select
distinct P#,J# from SPJ a11) R1y, (Select distinct J# from J a22) R2x where
R1y.P#=R1x.P# AND R1y.J#=R2x.J#) = (select count (*) from (Select distinct J#
from J a33 ) a44) ) a33 ) a44);

/* (12)  Problem (2) redone as a restriction of a Cartesian product */

Select distinct snumx FROM (( Select distinct * from (Select distinct * from
(Select distinct * from (( Select distinct S# snumx,P# pnumx FROM SPJ ))a888
 cross join (( Select distinct P# pnum,COLOR FROM P ))a999)b333 cross join ((
Select distinct S# snumy,P# pnumy FROM SPJ ))b444)b333 cross join (( Select
distinct S# snumz,P# pnumz FROM SPJ ))b444 )) a555 WHERE pnumx=pnumy AND
snumy=snumz AND pnumz=pnum AND color='Red' ;

/* (13) Problem (2) redone specifiying the color='Red'codition as part of a restriction instead of the join. */

Select distinct SPJX.S#  from SPJ SPJX,SPJ SPJY,SPJ SPJZ,( Select distinct *
from  P  WHERE P.COLOR='Red'  ) PX WHERE SPJX.P#=SPJY.P# AND SPJY.S#=SPJZ.S#
AND SPJZ.P#=PX.P# ;


 go 
