/*1. Print the sname of suppliers who supply part P1. */

Select distinct S.SNAME  from S,SPJ WHERE SPJ.P#='P1' AND SPJ.S#=S.S# ;

/* 2.  Print the S# of suppliers who supply a part in a different city */

Select distinct SPJ.S#  from SPJ,S,P WHERE SPJ.S#=S.S# AND SPJ.P#=P.P# AND
S.CITY<>P.CITY ;

/* 3.  Print every combination of S, P, J records (this is called the Cartesian product of S, P, J) */

Select distinct * from (Select distinct * from (Select distinct * from  s )
a666  cross join (( Select distinct p#,pname,color,weight,city pcity FROM P
))a999)b333 cross join (( Select distinct j#,jname,city jcity FROM J ))b444;

/* 4.  Print the pairs of S#s such that the first supplier has higher status than the second supplier. */

Select distinct Sx.S#,Sy.S#  from S Sx,S Sy WHERE Sx.status>Sy.status ;

/* 5.  Print S# of suppliers who supply a red part to a London  project. */

Select distinct SPJ.S#  from P,J,SPJ WHERE P.color='Red' AND J.city='London'
AND P.P#=SPJ.P# AND J.J#=SPJ.J# ;

/* 5. with subexpressions */

Select distinct SPJ.S#  from SPJ,( Select distinct * from  P  WHERE color='Red'
 ) px,( Select distinct * from  J  WHERE city='London'  ) jy WHERE SPJ.P#=px.P#
AND SPJ.J#=jy.J# ;

/* 6.   Print the pairs of P#s of parts that have a supplier in common. */

Select distinct SPJx.P#,SPJy.P#  from SPJ SPJx,SPJ SPJy WHERE SPJx.S#=SPJy.S#
AND SPJx.P#<SPJy.P# ;

/* 7.  Print the S#s of suppliers who supply a red part and a green part. */

Select distinct SPJ.S#  from SPJ,P WHERE P.color='Red' AND SPJ.P#=P.P#
 INTERSECT Select distinct SPJ.S#  from SPJ,P WHERE P.color='Green' AND
SPJ.P#=P.P# ;

/* Print the S#s of suppliers who supply a red part but do not supply a green part. */

Select distinct SPJ.S#  from SPJ,P WHERE P.color='Red' AND SPJ.P#=P.P#  EXCEPT
Select distinct SPJ.S#  from SPJ,P WHERE P.color='Green' AND SPJ.P#=P.P# ;

/* 8.  Print the J#s of projects that get a part that is available from S1. */

Select distinct SPJx.J#  from SPJ SPJx,SPJ SPJy WHERE SPJy.S#='S1' AND
SPJx.P#=SPJy.P# ;


 go 
